#def Construction(targetlanes, targetdelays, inserters):
#    indices = filter(lambda i: targetdelays[i] is not None, range(3))
#    if len(indices) == 1: return True
#    targetlanes = [targetlanes[i] for i in indices]
#    targetdelays = [targetdelays[i] for i in indices]
#    inserters = [inserters[i] for i in indices]
#    heights = [inserter[1].box[3] for inserter in inserters]
#    height = max(*heights) + 4
#    yoffs = [i * height for i in range(len(indices))]
#    outlanes, outdelays = zip(*(inserter[3].ld
#                                for inserter in inserters))
#    xoffs = [targetlane + yoff - outlane
#             for targetlane, yoff, outlane
#             in zip(targetlanes, yoffs, outlanes)]
#    moves = zip(xoffs, yoffs)
#    offdelays = [4 * y for y in yoffs]
#    delays = [targetdelay - offdelay - outdelay
#              for targetdelay, offdelay, outdelay
#              in zip(targetdelays, offdelays, outdelays)]
#    mindelay = min(delays)
#    normdelays = [delay - mindelay for delay in delays]
#    conduits = [inserter[1].translated(*move)
#                for inserter, move
#                in zip(inserters, moves)]
#    ingliders = [inserter[2][-delay].translated(*move)
#                 for inserter, move, delay
#                 in zip(inserters, moves, normdelays)]
#    orall = lambda z: reduce(lambda x, y: x | y, z)
#    pattern = orall(conduits) | orall(ingliders)
#    p, t, rc, partition = Outcome(pattern, 10000, strict=True)
#    if rc != 4: return
#    if len(partition) != 2: return
#    try:
#        if partition[0, 0] != orall(conduits): return
#        if partition[-1, -1].pop != len(indices) * 5 : return
#    except KeyError: return
#    return pattern.homed
#
#
#def AllConstructions(salvos, results, ResultDict):
#    result = []
#    lanes = [salvo._contents[0].x for salvo in salvos]
#    for inserterA in Inserters:
#        for inserterB in Inserters:
#            inserterC = Inserters[0]
#            inserters = (tuple(inserterA), tuple(inserterB),
#                         tuple(inserterC))
#            names = tuple(inserter[0] for inserter in inserters)
#            for perm in PERMS:
#                permlanes = tuple(lanes[i] for i in perm)
#                constructibles = ResultDict(list)
#                possible = dict()
#                for op, inslist in results.iteritems():
#                    if op.pop != 0: continue
#                    for ins in inslist:
#                        for cycle in ins._contents:
#                            delays = cycle._contents
#                            permdelays = tuple(delays[i] for i in perm)
#                            if permdelays not in possible:
#                                p = Construction(permlanes, permdelays,
#                                                 inserters)
#                                possible[permdelays] = p is not None
#                            isPoss = possible[permdelays]
#                            if not isPoss:
#                                break
#                        if isPoss:
#                            constructibles[op] += [ins]
#                            break
#                if constructibles.isComplete():
#                    result += [[names, permlanes, constructibles]]
#    return result
#
##print Construction((-3, 4, -5), (27, 10, 0), [Inserters[0]] * 3)
##print Construction((-3, -5, 4), (27, 0, 10), [Inserters[1]] * 3)

from rlife import P, G, X
from outcome import Outcome

PERMS = ((0, 1, 2), (0, 2, 1), (1, 0, 2),
         (1, 2, 0), (2, 0, 1), (2, 1, 0))

PERMS2 = ((0, 1), (1, 0))

FX119PATTERN = P("""
9bo$9bobo$9b3o$11bo5$bboo6boo$3bo7bo$3o5b3o$o7bo4$18boo$13boo3boo$13b
oo3$12boo12boo$13bo5boo5bo$10b3o6boo6b3o$10bo18bo!
""")

BEEHIVEPATTERN = P("""
6boo$5bobbo
$6boo19$103boo$103bo$101bobo$101boo4$9boo$9boo$$3bo$b3o$o$oo$20boo$20b
o$18bobo$18boo3$4boo$3bobo$3bo$bboo$$55boo$56bo$56bobo$57boo$39bo22bo$
7boo28b3o21bobo$8bo27bo24bobo$5b3o28boo24bo$5bo7$45boo25boo$45boo25bo$
70bobo$70boo$$8boo$8boo47boo$14boo32boo6bobo$14boo33bo6bo$49bobo3boo$
50boo$12boo$12boo5boo$19boo$39boo$39bo19boo7b3o$40b3o15bobo8bo$42bo15b
o8b3o$57boo5$75boo$75bobo$77bo$77boo!
""")

HTOG01PATTERN = P("""
7boo
$8bo$8bobo$9boo4$30boo$30boo$$9bo$9bobo$9b3o$11bo5$bboo$3bo$3o$o$20boo
$20boo!
""")

HTOG17PATTERN = P("""
15boo$16bo$16bobo$17boo
7$12boo$12boo$$oo$bo$bobo$bboo$39boo$39bobo$41bo$41boo3$31boo$31boo$$
16b3o$17bo8boo$17b3o6bo$27b3o$29bo4$10boo$9bobo$9bo$8boo!
""")

HTOGF1PATTERN = P("""
13boo$13boo$$25boo$4boo19boo$4boo5$31boo$30bobbo$31boo8$8b3o$9bo8boo$
9b3o6bo$19b3o$21bo4$bboo$bobo$bo$oo!
""")

HTOG1NPATTERN = P("""
bbo$3o$obo$o$11bo$10bobo$10bobo$11bo!
""")

Inserters = [
             ["119", FX119PATTERN],
             ["Bee", BEEHIVEPATTERN],
             ["#01", HTOG01PATTERN],
             ["#17", HTOG17PATTERN],
             ["F01", HTOGF1PATTERN],
             ["1NG", HTOG1NPATTERN]
             ]

def Initialize():
    global Inserters
    rInserters = []
    for inserter in Inserters:
        name, p = inserter
        q, t, rc, part = Outcome(p, 10000, True)
        gout = part[-1, -1][-t]
        h = p - part[0, 0]
        assert rc == 4
        assert h.pop == 7
        assert p[t] == (p - h + gout)[t] == (p - h)[t] + gout[t]
        inserter[0] = name + "L"
        inserter += [h, gout, t]
        rInserters += [[name + "R", X.D * p, X.D * h, X.D * gout, t]]
    Inserters += rInserters

Initialize()

Merges = dict()
GliderMoves = dict()
Constructibles = dict()

def IsConstructible(inserters, lanes, delays):
    
    def gmerge(i, j):
        if delays[i] is None or delays[j] is None:
            return None
        gout = inserters[i][3]
        lane = lanes[j] - lanes[i]
        delay = delays[j] - delays[i]
        key = (gout, delay, lane)
        try:
            result = GliderMoves[key]
        except KeyError:
            result = gout[-delay].translated(lane, 0)
            GliderMoves[key] = result
        return result
    
    def canMerge(i, salvo):
        if not salvo:
            return True
        salvo.setPeriod(4)
        name, p, h, gout, t = inserters[i]
        key = (name, salvo)
        try:
            result = Merges[key]
        except KeyError:
            result = ((p | salvo)[t] - p == (gout | salvo)[t] and
                      not (p - h).blocksNWSalvo(salvo))
            Merges[key] = result
        return result
    
    key = (inserters, lanes, delays)
    try:
        return Constructibles[key]
    except KeyError:
        pass
    if not canMerge(1, gmerge(1, 2)): result = False
    elif not canMerge(0, gmerge(0, 1)): result = False
    elif not canMerge(0, gmerge(0, 2)): result = False
    else:
        g1, g2 = gmerge(0, 1), gmerge(0, 2)
        if g1 and g2 and not canMerge(0, g1 | g2): result = False
        else: result = True
    Constructibles[key] = result
    return result

def AllConstructions(salvos, results, ResultDict):
    result = []
    lanes = [salvo._contents[0].x for salvo in salvos]
    for inserterA in Inserters:
        for inserterB in Inserters:
            inserterC = Inserters[0]
            inserters = (tuple(inserterA), tuple(inserterB),
                         tuple(inserterC))
            names = [inserter[0] for inserter in inserters]
            for perm in PERMS:
                permlanes = tuple(lanes[i] for i in perm)
                constructibles = ResultDict(list)
                for op, inslist in results.iteritems():
                    if op.pop != 0: continue
                    isCons = False
                    for inslen in xrange(1, 3):
                        for ins in inslist:
                            if len(ins._contents) != inslen: continue
                            for cycle in ins._contents:
                                delays = cycle._contents
                                permdelays = tuple(delays[i]
                                                   for i in perm)
                                isCons = IsConstructible(inserters,
                                                         permlanes,
                                                         permdelays)
                                if not isCons:
                                    break
                            if isCons:
                                constructibles[op] += [ins]
                                break
                        if isCons:
                            break
                if constructibles.isComplete():
                    result += [[names, permlanes, constructibles]]
    return result

def IsConstructible2(inserters, lanes, delays):
    
    def gmerge(i, j):
        if delays[i] is None or delays[j] is None:
            return None
        gout = inserters[i][3]
        lane = lanes[j] - lanes[i]
        delay = delays[j] - delays[i]
        key = (gout, delay, lane)
        try:
            result = GliderMoves[key]
        except KeyError:
            result = gout[-delay].translated(lane, 0)
            GliderMoves[key] = result
        return result
    
    def canMerge(i, salvo):
        if not salvo:
            return True
        salvo.setPeriod(4)
        name, p, h, gout, t = inserters[i]
        key = (name, salvo)
        try:
            result = Merges[key]
        except KeyError:
            result = ((p | salvo)[t] - p == (gout | salvo)[t] and
                      not (p - h).blocksNWSalvo(salvo))
            Merges[key] = result
        return result
    
    key = (inserters, lanes, delays)
    try:
        return Constructibles[key]
    except KeyError:
        pass
    result = canMerge(0, gmerge(0, 1))
    Constructibles[key] = result
    return result

def AllConstructions2(salvos, results, ResultDict):
    result = []
    lanes = [salvo._contents[0].x for salvo in salvos]
    for inserterA in Inserters:
        for inserterB in [Inserters[0]]:
            inserterC = Inserters[0]
            inserters = (tuple(inserterA), tuple(inserterB),
                         tuple(inserterC))
            names = [inserter[0] for inserter in inserters]
            for perm in PERMS2:
                permlanes = tuple(lanes[i] for i in perm)
                constructibles = ResultDict(list)
                for op, inslist in results.iteritems():
                    if op.pop != 0: continue
                    isCons = False
                    for inslen in xrange(1, 5):
                        for ins in inslist:
                            if len(ins._contents) != inslen: continue
                            for cycle in ins._contents:
                                delays = cycle._contents
                                permdelays = tuple(delays[i]
                                                   for i in perm)
                                isCons = IsConstructible2(inserters,
                                                          permlanes,
                                                          permdelays)
                                if not isCons:
                                    break
                            if isCons:
                                constructibles[op] += [ins]
                                break
                        if isCons:
                            break
                if constructibles.isComplete():
                    result += [[names[:2], permlanes, constructibles]]
    return result
